#!/usr/bin/python
# -*- coding: UTF-8 -*-

import os
import shutil
import sys
import pygtk
pygtk.require('2.0')
import gtk
import apt
import apt.gtk.widgets

PATH = "/usr/share/instalador-pdi"

class instaladorPDI:
	def __init__(self, user_exec_name):
		print 'Constructor'
		self.user_name = user_exec_name
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_position(gtk.WIN_POS_CENTER)
		self.window.set_border_width(10)
		self.window.set_title('Instalador de software PDI')
		self.window.connect("delete_event", self.delete_event)
                self.window.connect("destroy", self.destroy)

		self.et_info = gtk.Label()
		self.et_info.set_markup('<b>Seleccione su modelo de pizarra digital</b>')
		self.et_info.set_use_markup(True)
		self.et_smart = gtk.Label('Smartboard')
		self.et_prom = gtk.Label('Promethean')
		self.boton_smart = gtk.Button()
		self.boton_smart.set_tooltip_text('Instalar software para la pizarra digital Smartboard')
		self.imagen_smart = gtk.Image()
		self.imagen_smart.set_from_file('%s/img/smartboard.png' % PATH)
		self.watch = gtk.gdk.Cursor(gtk.gdk.HAND2)
		self.boton_smart.set_image(self.imagen_smart)
		self.boton_smart.connect("clicked", self.instalar_smartboard)
		self.boton_smart.connect("enter", lambda k:self.boton_smart.window.set_cursor(self.watch))
		self.boton_smart.connect("leave", lambda k:self.boton_smart.window.set_cursor(None))
		self.boton_prom = gtk.Button()
		self.boton_prom.set_tooltip_text('Instalar software para la pizarra digital Promethean')

		self.imagen_prom = gtk.Image()
		self.imagen_prom.set_from_file('%s/img/promethean.png' % PATH)
		self.boton_prom.set_image(self.imagen_prom)
		self.boton_prom.connect("clicked", self.instalar_promethean)
		self.boton_prom.connect("enter", lambda k:self.boton_prom.window.set_cursor(self.watch))
		self.boton_prom.connect("leave", lambda k:self.boton_prom.window.set_cursor(None))

		self.et_info_otras = gtk.Label()
		self.et_info_otras.set_markup('<b>Otros modelos de PDI</b>')
		self.et_info_otras.set_use_markup(True)
		self.et_mimio = gtk.Label('Mimio PDI')
		self.boton_mimio = gtk.Button()
		self.boton_mimio.set_tooltip_text('Instalar software para la pizarra digital Mimio')
		self.imagen_mimio = gtk.Image()
		self.imagen_mimio.set_from_file('%s/img/mimio.png' % PATH)
		self.boton_mimio.set_image(self.imagen_mimio)
		self.boton_mimio.connect("clicked", self.instalar_mimio)
		self.boton_mimio.connect("enter", lambda k:self.boton_mimio.window.set_cursor(self.watch))
		self.boton_mimio.connect("leave", lambda k:self.boton_mimio.window.set_cursor(None))
		
		self.vbox = gtk.VBox(False, 10)
		self.hbox_info = gtk.HBox(False, 10)
		self.hbox_etiq_bot = gtk.HBox(False, 10)
		self.hbox_botones = gtk.HBox(False, 10)
		self.hbox_install = gtk.HBox(False, 10)
		self.hbox_info_otras = gtk.HBox(False, 10)
		self.hbox_etiq_bot_otras = gtk.HBox(False, 10)
		self.hbox_botones_otras = gtk.HBox(False, 10)
		
		self.window.add(self.vbox)
		self.hbox_info.pack_start(self.et_info,True, True, 0)
		self.vbox.pack_start(self.hbox_info,True, True, 0)
		self.hbox_botones.pack_start(self.boton_prom, True, True, 0)
		self.hbox_botones.pack_start(self.boton_smart, True, True, 0)
		self.vbox.pack_start(self.hbox_botones, True, True, 0)
		self.hbox_etiq_bot.pack_start(self.et_prom, True, True, 0)
		self.hbox_etiq_bot.pack_start(self.et_smart, True, True, 0)
		self.vbox.pack_start(self.hbox_etiq_bot, True, True, 0)
		
		self.hbox_info_otras.pack_start(self.et_info_otras, True, True, 0)
		self.vbox.pack_start(self.hbox_info_otras, True, True, 0)
		self.hbox_botones_otras.pack_start(self.boton_mimio, True, False, 0)
		self.vbox.pack_start(self.hbox_botones_otras, True, True, 0)
		self.hbox_etiq_bot_otras.pack_start(self.et_mimio, True, True, 0)
		self.vbox.pack_start(self.hbox_etiq_bot_otras, True, True, 0)

		self.vbox.pack_start(self.hbox_install, True, True, 10)

		(self.tam_original_width, self.tam_original_height) = self.window.get_size()
		self.window.show_all()

	def instalar_promethean(self, widget, data = None):
		print 'Instalacion de Promethean'
		paquetes=['activ-meta-es','activinspire-licence']

		self.instalacion_paquetes(paquetes)

	def instalar_smartboard(self, widget, data = None):
		print 'Instalacion de Smartboard'
		#paquetes=['cga-pdi-smartboard-software']
		#self.instalacion_paquetes(paquetes)
		self.aviso = gtk.Dialog('Aviso', None, gtk.DIALOG_MODAL, None)
                menaviso = gtk.Label('Software no disponible en esta aplicación, para instalar el\nsoftware para pizarras SmartBoard debe acceder a la\naplicación "Instalador Smart Board Software" dentro del\nmenú Aplicaciones -> Accesorios')
                menaviso.show()
                self.aviso.vbox.pack_start(menaviso, True, True, 20)
                self.aviso.add_button('Aceptar', 2222)
                self.aviso.connect('response', self.cerrar_aviso)
                self.aviso.run()

	def instalar_mimio(self, widget, data = None):
		print 'Instalacion de Mimio'
		paquetes=['mimio-studio']
		self.instalacion_paquetes(paquetes)
		if os.access('/home/%s/.mimio' % self.user_name, os.F_OK):
			shutil.rmtree('/home/%s/.mimio' % self.user_name)
	
	def instalacion_paquetes(self, lista):
		self.estado_final = 0
		self.vbox_install = gtk.VBox(False, 10)
		self.hbox_actividad = gtk.HBox(False, 10)
		self.boton_prom.set_sensitive(False)
		self.boton_smart.set_sensitive(False)
		self.boton_mimio.set_sensitive(False)
		self.boton_terminar = gtk.Button()
		self.boton_terminar.set_sensitive(False)
		self.boton_terminar.set_label('Continuar')
		self.boton_terminar.connect("clicked", self. terminar_instalacion)
		self.progreso = apt.gtk.widgets.GtkAptProgress()
		self.hbox_actividad.pack_start(self.progreso, True, True, 0)
		self.hbox_actividad.pack_start(self.boton_terminar, False, False, 0)
		self.vbox_install.pack_start(self.hbox_actividad, True, True, 0)
		self.hbox_install.pack_start(self.vbox_install, True, True, 0)
		self.hbox_actividad.show()
		self.vbox_install.show()
		self.boton_terminar.show()
		self.progreso.show()
		try:
			cache = apt.cache.Cache(self.progreso.open)
			for paq in lista:
				if cache[paq].isInstalled:
					print 'Paquete instalado'
				else:
					cache[paq].markInstall()
			cache.commit(self.progreso.fetch, self.progreso.install)
		except KeyError, msg:
			self.estado_final = 1
			self.et_error = gtk.Label('Error: No existe el paquete %s' % msg)
			self.vbox_install.pack_start(self.et_error, True, True, 0)
			self.et_error.show()
			pass
		except Exception, msg:
			self.estado_final = 1
			self.et_error = gtk.Label('Error: %s' % msg)
			self.vbox_install.pack_start(self.et_error, True, True, 0)
			self.et_error.show()
			pass
		self.boton_terminar.set_sensitive(True)

	def terminar_instalacion(self, widget, data = None):
		print data
		if self.estado_final == 1:
			self.et_error.destroy()	
		self.progreso.destroy()
		self.boton_terminar.destroy()
		self.hbox_actividad.destroy()
		self.vbox_install.destroy()
		self.boton_prom.set_sensitive(True)
		self.boton_smart.set_sensitive(True)
		self.boton_mimio.set_sensitive(True)
		self.window.resize(self.tam_original_width, self.tam_original_height)
		
	def cerrar_aviso(self, widget, data = None):
                self.aviso.destroy()

	def delete_event(self, widget, data = None):
		gtk.main_quit()

	def destroy(self, widget, data = None):
		gtk.main_quit()

def main():
	gtk.main()

if __name__=="__main__":
	ent = None
	if len(sys.argv) == 2:
		ent = sys.argv[1]
	app = instaladorPDI(ent)
	main()
